/*-
 * Copyright (C)2003 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * $Id: mife.h,v 1.4 2004/11/06 04:56:46 babolo Exp $
 */

#define MIFE_RTRY    0x0000FF
#define MIFE_BUFL    0x000F00
#define MIFE_INMM    0x010000 /*             */
#define MIFE_ALLC    0x020000 /*    free()       */
#define MIFE_MMAP    0x040000 /*  mmaped                   */
#define MIFE_CLOS    0x080000 /*    fd          */
#define MIFE_EOFL    0x100000 /*             */
#define MIFE_FULL    0x200000 /*   \0           */
#define MIFE_PIPE    0x400000 /*       */
#define MIFE_BUFX    0x800000 /*        */

#define kukMIFE_RTRY(x) ((u_int32_t)(x) & MIFE_RTRY)
#define setMIFE_RTRY(a,x) {(a) &= ~MIFE_RTRY; (a) |= kukMIFE_RTRY(x);}
#define getMIFE_RTRY(a) ((a) & MIFE_RTRY)
#define kukMIFE_BUFL(x) (((u_int32_t)(x) << 8) & MIFE_BUFL)
#define setMIFE_BUFL(a,x) {(a) &= ~MIFE_BUFL; (a) |= kukMIFE_BUFL(x);}
#define getMIFE_BUFL(a) (((a) >> 8) & (MIFE_BUFL >> 8))

struct mife_descriptor {
    u_int32_t flag;   /*                             */
    int fd;           /*          */
    ssize_t mindelta;
    size_t  actlen;   /*         */
    size_t  buflen;   /*                      */
    void   *buffer;   /*                             */
    off_t   offset;   /*       */
    off_t   st_size;  /*   ( )         */
    mode_t  st_mode;  /*                         */
};

struct mife_descriptor * mife_opef __P((u_int32_t, int));
struct mife_descriptor * mife_open __P((u_int32_t, const char *));
struct mife_descriptor * mife_opes __P((u_int32_t, const char *, size_t));
struct mife_descriptor * mife_opem __P((u_int32_t, char *, size_t));

ssize_t mife_read __P((struct mife_descriptor *, ssize_t, off_t, const char *));
void *   mife_get __P((struct mife_descriptor *, off_t));
int    mife_close __P((struct mife_descriptor *));
ssize_t mife_writ __P((int, const void *, size_t));
